/*************************************************************************
* MediaCoder - The universal audio/video transcoder
*
* Copyright (c) 2005-06 Stanley Huang <reachme@citiz.net>
* All rights reserved.
*************************************************************************/

#include "atlstr.h"
#include "cfilename.h"

void CFileName::GetDir(CString& result)
{
	int i = string.ReverseFind('\\');
	if (i == -1) return;
	result += string.Left(i + 1);
}

void CFileName::GetName(CString& result)
{
	int i = string.ReverseFind('\\');
	if (i == -1)
		result += string;
	else
		result += string.Mid(i + 1);
}

void CFileName::GetExtName(CString& result)
{
	int i = string.ReverseFind('.');
	if (i == -1) return;
	result += string.Mid(i + 1);
}

void CFileName::SetExtName(TCHAR* pszExt)
{
	int i = string.ReverseFind('.');
	if (i != -1) {
		string.Delete(i + 1, string.GetLength() - i);
	} else {
		string += '.';
	}
	string += pszExt;
}

void CFileName::RemoveExtName()
{
	int i = string.ReverseFind('.');
	if (i != -1) {
		string.Delete(i, string.GetLength() - i + 1);
	}
}

void CFileName::RemoveDriveLetter()
{
	if (string.Mid(1, 2) == ":\\") string.Delete(0, 3);
}

void CFileName::RemovePathName()
{
	int i = string.ReverseFind('\\');
	if (i >= 0) string.Delete(0, i + 1);
}

void CFileName::operator=( CString& str )
{
	string = str;
}

void CFileName::operator=( TCHAR* pszData )
{
	string = pszData;
}

void CFileName::operator+=( CString& str )
{
	string += str;
}

void CFileName::operator+=( TCHAR* pszData )
{
	string += pszData;
}
