#define FLAG_REQUEST_ONLY 0x1
#define FLAG_CLOSE_CONN 0x2
#define FLAG_KEEP_HEADER 0x4
#define FLAG_CHUNKED 0x8

typedef enum {
	HS_IDLE=0,
	HS_REQUESTING,
	HS_RECEIVING,
} httpStates;

typedef enum {
	HM_GET = 0,
	HM_POST,
	HM_HEAD,
} httpMethods;

typedef struct {
	int sockfd;
	httpMethods method;
	httpStates state;
	char *url;
	char *proxy;
	unsigned short flags;
	unsigned short port;
	char* header;
	char* buffer;
	char* postData;
	int iPostDataSize;
	int iDataSize;
	int iBytesStart;
	int iBytesEnd;
	int iPayloadSize;
	//info parsed from response header
	char* contentType;
	int iHttpCode;
} httpRequest;

#ifdef __cplusplus
extern "C" {
#endif

void initHttpReq(httpRequest* req, char* url, char* proxy);
int httpGet(httpRequest* param);

#ifdef __cplusplus
}
#endif
