#ifndef XMLACCESSOR_H
#define XMLACCESSOR_H

#include <libxml/xpath.h>

typedef enum {
	XA_READ = 0,
	XA_WRITE,
} XA_MODE;

class CXML
{
public:
	CXML():doc(0),value(0),result(0),xmlfile(0) {}
	~CXML() { Close(); }
	void New(char* xmlVersion, char* rootNodeName, char* rootNodeValue = 0);
	int Open(char* filename);
	int Save(char* filename, char* encoding = 0);
	int Read(char* xmlbuf, char* url = 0, char* encoding = 0);
	int Dump(char** buffer, char* encoding = 0);

	//navigation methods
	xmlNodePtr goToKey(char *path, int index = 0);
	xmlNodePtr goRoot();
	xmlNodePtr goNext(xmlNodePtr node = 0);
	xmlNodePtr goPrev(xmlNodePtr node = 0);
	xmlNodePtr goChild(xmlNodePtr node = 0);
	xmlNodePtr goParent(xmlNodePtr node = 0);

	//get/set methods
	xmlNodePtr addChild(char* nodename, char* value = 0, xmlNodePtr node = 0);
	xmlAttrPtr addAttribute(char* name, char* value, xmlNodePtr node = 0);
	xmlAttrPtr setAttribute(char* name, char* value, xmlNodePtr node = 0);
	xmlNodePtr findNode(char* name, char* attrname =0, char* attrvalue = 0, xmlNodePtr node = 0);
	int getChildCount(xmlNodePtr node = 0);
	void setNodeName(char* nodename, xmlNodePtr node = 0);
	void setNodeValue(char* value, xmlNodePtr node = 0);
	char* getNodeName(xmlNodePtr node = 0);
	char* getNodeValue(int index = 0, xmlNodePtr node = 0);
	char* getChildName(int index);
	char* getAttribute(char* propname, xmlNodePtr node = 0);
	int getAttributeInt(char* propname, int def = 0, xmlNodePtr node = 0);
	bool isMatched(char* match, xmlNodePtr node = 0);
	void Close();
	static void Init();
	static void Cleanup();
private:
	xmlNodePtr cur;
	xmlDocPtr doc;
	xmlXPathObjectPtr result;
	xmlChar *value;
	char* xmlfile;
};

#endif