;************************************************************
;űд: Felix.Wang
;: ʹ NSIS v2.03 °汾
;************************************************************

!define              PRODUCT_NAME "MediaCoder Audio Edition"
!define              VER_MAJOR   "0.5"
!define              VER_MINOR   "0"
!define              PRODUCT_VERSION "${VER_MAJOR}.${VER_MINOR}"
!define              PRODUCT_PUBLISHER "Stanley Huang"
!define              PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\mediacoder.exe"
!define              PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define              PRODUCT_UNINST_ROOT_KEY "HKLM"

!define              MAX_INSTTYPE 5 ;װ
!define              FILE_PATH "../release" ;װļĿ¼
!define              MAIN_APP "$INSTDIR\mediacoder.exe"
Name                 "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile              "MediaCoderAudioEdition.exe"

SetCompressor        /FINAL /SOLID lzma
SpaceTexts           none
ShowInstDetails      show
ShowUninstDetails    show
BrandingText         "${PRODUCT_NAME} $(INSTALLER) ${__DATE__}"
Caption              "$(^Name)"
UninstallCaption     "$(^Name) $(UNINSTALLER)"
ComponentText        "" "$(COMPONENT_INST_TYPE)" "----------------------"
InstallDir           "$PROGRAMFILES\${PRODUCT_NAME}"
InstallDirRegKey     HKLM "${PRODUCT_DIR_REGKEY}" ""

ReserveFile          "${NSISDIR}\Plugins\System.dll"
ReserveFile          "${NSISDIR}\Plugins\LangDLL.dll"

!include             MUI.nsh
!include             Language.nsh
!addincludedir       "..\[MyFunctions]"
!include             BlueHelper.nsh

; MUI Settings(GLOBAL)
!define MUI_ABORTWARNING
!define MUI_ICON ".\resource\ico-inst.ico"
!define MUI_UNICON ".\resource\ico-inst.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP ".\resource\header-foobar.bmp"
!define MUI_COMPONENTSPAGE_CHECKBITMAP ".\resource\plastic.bmp"

;----------------------------------- insert page
; Welcome page
!define MUI_WELCOMEFINISHPAGE_BITMAP ".\resource\wiz-foobar.bmp"
!define MUI_WELCOMEPAGE_TEXT "$(WELCOMEPAGE_TEXT)"
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChkBeforeInstall
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "$(license)"
; Setup directory page
!insertmacro MUI_PAGE_DIRECTORY
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChangeFont	
!define MUI_FINISHPAGE_LINK "$(FORUM)"
!define MUI_FINISHPAGE_LINK_LOCATION "$(PRODUCT_WEB_SITE)"
!define MUI_FINISHPAGE_RUN "${MAIN_APP}"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\whatsnew.txt"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!insertmacro MUI_PAGE_FINISH
	
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;language page	
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "SimpChinese"
ChangeUI IDD_SELCOM ".\resource\myui.exe"

!define File `!insertmacro File`

!macro File FILE
       File "${FILE_PATH}\${FILE}"
!macroend	

Function ChangeFont
        GetDlgItem $0 $MUI_HWND 1201
        CreateFont $1 "Tahoma" "11" "700"
        SendMessage $0 ${WM_SETFONT} $1 0
FunctionEnd	

Function ChkBeforeInstall
;  ${IsWinNT} $0
;  ${If} $0 = ${FALSE}
;  	MessageBox MB_OK|MB_ICONEXCLAMATION "$(WIN9X_WARNING)"
;  ${EndIf}
FunctionEnd	

; *****************************************install type

InstType "$(INST_TYPE1)" ;1 - Full
InstType "$(INST_TYPE2)" ;2 - Audio Only
InstType "$(INST_TYPE3)" ;3 - Minimum

Section "$(Main)" main_components
  SectionIn 1 2 3 RO
	
	;һĸתΪд
	${UpperDrvChar} $INSTDIR
	
	;ǷҪرеMediaCoder
	${IsWritable} $0 "${MAIN_APP}"
	${If} $0 = ${FALSE}
		LockWindow on
		${For} $1 0 20
                        MessageBox MB_OK|MB_ICONINFORMATION "$(WAIT_CLOSE)"
			${IsWritable} $0 "${MAIN_APP}"
			${If} $0 = ${TRUE}
				${ExitFor}
			${EndIf}
		${Next}
		LockWindow off
	${EndIf}
	
        SetOutPath "$INSTDIR"
	SetOverwrite ifnewer

        ${IsWinNT} $0
        ${If} $0 = ${TRUE}
  	      ${File} "mediacoder.exe"
  	${Else}
  	       File /oname=mediacoder.exe "${FILE_PATH}\mediacoder-w9x.exe"
        ${EndIf}
        ${File} "mccore.dll"
        ${File} "mccore.xml"
        ${File} "msvcr71.dll"
	${File} "libxml2.dll"
	${File} "libiconv2.dll"
	${File} "MediaInfo.dll"
	File "..\website\whatsnew.txt"
        SetOutPath "$INSTDIR\htdocs"
        File /r "${FILE_PATH}\htdocs\pref"
        File /r "${FILE_PATH}\htdocs\setup"
	SetOutPath "$INSTDIR\mplayer"
	${File} "mplayer\mplayer.exe"
	${File} "mplayer\MPUI.exe"
	SetOutPath "$INSTDIR\mplayer\mplayer"
	${File} "mplayer\mplayer\input.conf"
	${File} "mplayer\mplayer\mplayer.conf"
	SetOutPath "$INSTDIR\tools"
	${File} "tools\Tag.exe"
	${File} "tools\neroAacTag.exe"
	${File} "tools\ifodump.exe"
	${File} "tools\libdvdnav-4.dll"
	${File} "tools\ssrc.exe"
SectionEnd

Section "$(Audio)" audio_components
	SectionIn 1 2 3 ;full and audio only
        SetOutPath "$INSTDIR\plugins"
	${File} "plugins\in_*.dll"
        SetOutPath "$INSTDIR\codecs"
        ${File} "codecs\oggenc2.exe"
	;${File} "codecs\enc_aacplus.dll"
	${File} "codecs\ct-libisomedia.dll"
	${File} "codecs\aacPlusEnc.dll"
	${File} "codecs\faac.exe"
	${File} "codecs\mp4als.exe"
	${File} "codecs\mppenc.exe"
	${File} "codecs\cscript.exe"
	${File} "codecs\WMCmd.vbs"
	${File} "codecs\MACDll.dll"
	${File} "codecs\flac.exe"
	${File} "codecs\wavpack.exe"
	${File} "codecs\ofr.exe"
	${File} "codecs\hmp3.exe"
	${File} "codecs\neroAacEnc.exe"
SectionEnd
	
Section "$(ShortCut)" shortcut
  SectionIn 1 2 3
  CreateDirectory "$SMPROGRAMS\MediaCoder"
  CreateShortCut "$SMPROGRAMS\MediaCoder\MediaCoder's Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\MediaCoder\MediaCoder.lnk" "${MAIN_APP}"
  CreateShortCut "$SMPROGRAMS\MediaCoder\Uninstall MediaCoder.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section "$(Desktop_ShortCut)" desktop_shortcut
  SectionIn 1 2
  CreateShortCut "$DESKTOP\MediaCoder.lnk" "${MAIN_APP}"
SectionEnd

Section "$(Quick_ShortCut)" quick_shortcut
  CreateShortCut "$QUICKLAUNCH\MediaCoder.lnk" "${MAIN_APP}"
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "$(PRODUCT_WEB_SITE)"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "${MAIN_APP}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "${MAIN_APP}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "$(PRODUCT_WEB_SITE)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd
; --------------------------------------

Function .onInit
	InitPluginsDir
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "$(^Name)") i .r1 ?e'
	Pop $0 
	StrCmp $0 0 +3 
		MessageBox MB_OK|MB_ICONEXCLAMATION "$(Mutex)" 
		Quit
		
	!insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

;Function .onSelChange ;set dependent in this function
;FunctionEnd

Function .onMouseOverSection
	!insertmacro MUI_DESCRIPTION_BEGIN
	
	!insertmacro MUI_DESCRIPTION_TEXT ${main_components} "$(Main_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${audio_components} "$(Audio_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${shortcut} "$(ShortCut_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${desktop_shortcut} "$(Desktop_ShortCut_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${quick_shortcut} "$(Quick_ShortCut_Description)"
        !insertmacro MUI_DESCRIPTION_END
FunctionEnd

; --------------------------------------
; жض
; --------------------------------------

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\mplayer\mplayer\*"
  Delete "$INSTDIR\mplayer\*.*"
  Delete "$INSTDIR\codecs\*.*"
  Delete "$INSTDIR\tools\*.*"
  Delete "$INSTDIR\plugins\*.*"

  Delete "$INSTDIR\mediacoder.exe"
  Delete "$INSTDIR\*.dll"
  Delete "$INSTDIR\*.xml"
  Delete "$INSTDIR\mediacoder.ini"
  Delete "$INSTDIR\mediacoder.m3u"
  Delete "$INSTDIR\whatsnew.txt"
  Delete "$INSTDIR\readme.txt"

  Delete "$SMPROGRAMS\MediaCoder\Uninstall MediaCoder.lnk"
  Delete "$SMPROGRAMS\MediaCoder\MediaCoder's Website.lnk"
  Delete "$DESKTOP\MediaCoder.lnk"
  Delete "$QUICKLAUNCH\MediaCoder.lnk"
  Delete "$SMPROGRAMS\MediaCoder\MediaCoder.lnk"

  RMDir "$SMPROGRAMS\MediaCoder"
  RMDir /r "$INSTDIR\htdocs"
  RMDir "$INSTDIR\mplayer\mplayer\font"
  RMDir "$INSTDIR\mplayer\mplayer"
  RMDir "$INSTDIR\mplayer"
  RMDir "$INSTDIR\codecs"
  RMDir "$INSTDIR\plugins"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"

  ${RefreshIcon}
  SetAutoClose true
SectionEnd
