!define              PRODUCT_NAME "MediaCoder"
!define              VER_MAJOR   "0.5"
!define              VER_MINOR   "0"
!define              PRODUCT_VERSION "${VER_MAJOR}.${VER_MINOR}"
!define              PRODUCT_PUBLISHER "Stanley Huang"
!define              PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\mediacoder.exe"

!define              FILE_PATH "../release" ;װļĿ¼
!define              MAIN_APP "$INSTDIR\mediacoder.exe"

Name                 "${PRODUCT_NAME} ${VER_MAJOR}.${VER_MINOR} $(UPDATE)"
OutFile              "mediacoder-update.exe"

SetCompressor        /FINAL /SOLID lzma
SpaceTexts           none
;ShowInstDetails      show
;ShowUninstDetails    show
BrandingText         "${PRODUCT_NAME} $(INSTALLER) ${__DATE__}"
Caption              "$(^Name)"
InstallDir           "$PROGRAMFILES\${PRODUCT_NAME}"
InstallDirRegKey     HKLM "${PRODUCT_DIR_REGKEY}" ""

ReserveFile          "${NSISDIR}\Plugins\System.dll"
ReserveFile          "${NSISDIR}\Plugins\LangDLL.dll"

!include             MUI.nsh
!include             Language.nsh
!addincludedir       "..\[MyFunctions]"
!include             BlueHelper.nsh

; MUI Settings(GLOBAL)
!define MUI_ABORTWARNING
!define MUI_ICON ".\resource\ico-inst.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP ".\resource\header-foobar.bmp"

;----------------------------------- insert page
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChkBeforeInstall
; Welcome page
;!define MUI_WELCOMEFINISHPAGE_BITMAP ".\resource\wiz-foobar.bmp"
;!define MUI_WELCOMEPAGE_TEXT "$(WELCOMEPAGE_TEXT)"
;!insertmacro MUI_PAGE_WELCOME
; Setup directory page
!insertmacro MUI_PAGE_DIRECTORY
; Components page
;!insertmacro MUI_PAGE_COMPONENTS
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChangeFont	
!define MUI_FINISHPAGE_RUN "${MAIN_APP}"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\whatsnew.txt"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!insertmacro MUI_PAGE_FINISH
	
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;language page	
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "SimpChinese"
;ChangeUI IDD_SELCOM ".\resource\myui.exe"

!define File `!insertmacro File`

!macro File FILE
       File "${FILE_PATH}\${FILE}"
!macroend	

Function ChangeFont
        GetDlgItem $0 $MUI_HWND 1201
        CreateFont $1 "Tahoma" "11" "700"
        SendMessage $0 ${WM_SETFONT} $1 0
FunctionEnd	

Function ChkBeforeInstall
;  ${IsWinNT} $0
;  ${If} $0 = ${FALSE}
;  	MessageBox MB_OK|MB_ICONEXCLAMATION "$(WIN9X_WARNING)"
;  	Quit
;  ${EndIf}
FunctionEnd

Section "$(Main)" main_components
  SectionIn 1 RO
	
	;һĸתΪд
	${UpperDrvChar} $INSTDIR
	
	;FindFirst $0 $1 ${MAIN_APP}
        ;StrCmp $1 "" nofound pass
        ;nofound:
        ;MessageBox MB_OK|MB_ICONINFORMATION "$(FULL_PACK_NO_FOUND)"
        ;Quit
        ;pass:
        
	;ǷҪرеMediaCoder
	${IsWritable} $0 "${MAIN_APP}"
	${If} $0 = ${FALSE}
		LockWindow on
		${For} $1 0 20
                        MessageBox MB_OK|MB_ICONINFORMATION "$(WAIT_CLOSE)"
			${IsWritable} $0 "${MAIN_APP}"
			${If} $0 = ${TRUE}
				${ExitFor}
			${EndIf}
		${Next}
		LockWindow off
	${EndIf}
	
	SetOutPath "$INSTDIR"
        ${IsWinNT} $0
        ${If} $0 = ${TRUE}
  	      ${File} "mediacoder.exe"
  	${Else}
  	       File /oname=mediacoder.exe "${FILE_PATH}\mediacoder-w9x.exe"
        ${EndIf}
        ${File} "mccore.dll"
        ${File} "mccore.xml"
        ${File} "MediaInfo.dll"
	File "..\website\whatsnew.txt"
	SetOutPath "$INSTDIR\plugins"
	${File} "plugins\dev_videodisc.dll"
	${File} "plugins\dev_videodisc.xml"
        SetOutPath "$INSTDIR\htdocs"
        File /r "${FILE_PATH}\htdocs\img"
        File /r "${FILE_PATH}\htdocs\pref"
        File /r "${FILE_PATH}\htdocs\setup"
SectionEnd

; --------------------------------------

Function .onInit
	InitPluginsDir
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "$(^Name)") i .r1 ?e'
	Pop $0
	StrCmp $0 0 +3
		MessageBox MB_OK|MB_ICONEXCLAMATION "$(Mutex)"
		Quit
		
	!insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

