;************************************************************
;űд: Felix.Wang
;: ʹ NSIS v2.03 °汾
;************************************************************

!define              PRODUCT_NAME "MediaCoder"
!define              VER_MAJOR   "0.5"
!define              VER_MINOR   "0"
!define              PRODUCT_VERSION "${VER_MAJOR}.${VER_MINOR}"
!define              PRODUCT_PUBLISHER "Stanley Huang"
!define              PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\mediacoder.exe"
!define              PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define              PRODUCT_UNINST_ROOT_KEY "HKLM"

!define              MAX_INSTTYPE 5 ;װ
!define              FILE_PATH "../release" ;װļĿ¼
!define              MAIN_APP "$INSTDIR\mediacoder.exe"
Name                 "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile              "${PRODUCT_NAME}-${PRODUCT_VERSION}.exe"

SetCompressor        /FINAL /SOLID lzma
SpaceTexts           none
ShowInstDetails      show
ShowUninstDetails    show
BrandingText         "${PRODUCT_NAME} $(INSTALLER) ${__DATE__}"
Caption              "$(^Name)"
UninstallCaption     "$(^Name) $(UNINSTALLER)"
ComponentText        "" "$(COMPONENT_INST_TYPE)" "----------------------"
InstallDir           "$PROGRAMFILES\${PRODUCT_NAME}"
InstallDirRegKey     HKLM "${PRODUCT_DIR_REGKEY}" ""

ReserveFile          "${NSISDIR}\Plugins\System.dll"
ReserveFile          "${NSISDIR}\Plugins\LangDLL.dll"

!include             MUI.nsh
!include             Language.nsh
!addincludedir       "..\[MyFunctions]"
!include             BlueHelper.nsh

; MUI Settings(GLOBAL)
!define MUI_ABORTWARNING
!define MUI_ICON ".\resource\ico-inst.ico"
!define MUI_UNICON ".\resource\ico-inst.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP ".\resource\header-foobar.bmp"
!define MUI_COMPONENTSPAGE_CHECKBITMAP ".\resource\plastic.bmp"

;----------------------------------- insert page
; Welcome page
!define MUI_WELCOMEFINISHPAGE_BITMAP ".\resource\wiz-foobar.bmp"
!define MUI_WELCOMEPAGE_TEXT "$(WELCOMEPAGE_TEXT)"
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChkBeforeInstall
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "$(license)"
; Setup directory page
!insertmacro MUI_PAGE_DIRECTORY
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChangeFont	
!define MUI_FINISHPAGE_LINK "$(FORUM)"
!define MUI_FINISHPAGE_LINK_LOCATION "$(PRODUCT_WEB_SITE)"
!define MUI_FINISHPAGE_RUN "${MAIN_APP}"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\whatsnew.txt"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!insertmacro MUI_PAGE_FINISH
	
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;language page	
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "SimpChinese"
ChangeUI IDD_SELCOM ".\resource\myui.exe"

!define File `!insertmacro File`

!macro File FILE
       File "${FILE_PATH}\${FILE}"
!macroend	

Function ChangeFont
        GetDlgItem $0 $MUI_HWND 1201
        CreateFont $1 "Tahoma" "11" "700"
        SendMessage $0 ${WM_SETFONT} $1 0
FunctionEnd	

Function ChkBeforeInstall
;  ${IsWinNT} $0
;  ${If} $0 = ${FALSE}
;  	MessageBox MB_OK|MB_ICONEXCLAMATION "$(WIN9X_WARNING)"
;  ${EndIf}
FunctionEnd	

; *****************************************install type

InstType "$(INST_TYPE1)" ;1 - Full
InstType "$(INST_TYPE2)" ;2 - Audio Only
InstType "$(INST_TYPE3)" ;3 - Minimum

Section "$(Main)" main_components
  SectionIn 1 2 3 RO
	
	;һĸתΪд
	${UpperDrvChar} $INSTDIR
	
	;ǷҪرеMediaCoder
	${IsWritable} $0 "${MAIN_APP}"
	${If} $0 = ${FALSE}
		LockWindow on
		${For} $1 0 20
                        MessageBox MB_OK|MB_ICONINFORMATION "$(WAIT_CLOSE)"
			${IsWritable} $0 "${MAIN_APP}"
			${If} $0 = ${TRUE}
				${ExitFor}
			${EndIf}
		${Next}
		LockWindow off
	${EndIf}
	
        SetOutPath "$INSTDIR"
	SetOverwrite ifnewer

        ${IsWinNT} $0
        ${If} $0 = ${TRUE}
  	      ${File} "mediacoder.exe"
  	${Else}
  	       File /oname=mediacoder.exe "${FILE_PATH}\mediacoder-w9x.exe"
        ${EndIf}
        ${File} "mccore.dll"
        ${File} "mccore.xml"
        ${File} "mc.exe"
        ${File} "msvcr71.dll"
	${File} "libxml2.dll"
	${File} "libiconv2.dll"
	${File} "MediaInfo.dll"
	File "..\website\whatsnew.txt"
        SetOutPath "$INSTDIR\htdocs"
        File /r "${FILE_PATH}\htdocs\img"
        File /r "${FILE_PATH}\htdocs\pref"
        File /r "${FILE_PATH}\htdocs\setup"
	SetOutPath "$INSTDIR\plugins"
	${File} "plugins\dev_*.dll"
	${File} "plugins\dev_*.xml"
	SetOutPath "$INSTDIR\mplayer"
	${File} "mplayer\mplayer.exe"
	${File} "mplayer\drv*.dll"
	${File} "mplayer\atrc3260.dll"
	${File} "mplayer\cook3260.dll"
	${File} "mplayer\pncrt.dll"
	${File} "mplayer\sipr3260.dll"
	${File} "mplayer\tokr3260.dll"
	${File} "mplayer\MPUI.exe"
	SetOutPath "$INSTDIR\mplayer\mplayer"
	${File} "mplayer\mplayer\input.conf"
	${File} "mplayer\mplayer\mplayer.conf"
	SetOutPath "$INSTDIR\mplayer\mplayer\font"
	${File} "mplayer\mplayer\font\font.desc"
	${File} "mplayer\mplayer\font\iso-8859-1-a.raw"
	${File} "mplayer\mplayer\font\iso-8859-1-b.raw"
	${File} "mplayer\mplayer\font\osd-mplayer-a.raw"
	${File} "mplayer\mplayer\font\osd-mplayer-b.raw"
	SetOutPath "$INSTDIR\tools"
	${File} "tools\Tag.exe"
	${File} "tools\neroAacTag.exe"
	${File} "tools\ifodump.exe"
	${File} "tools\libdvdnav-4.dll"
	${File} "tools\ssrc.exe"
SectionEnd

SubSection "$(Audio)" audio_components
	Section "$(Winamp_in_Plugin)" winamp_in_plugin_components
		SectionIn 1 2  ;full and audio only
                SetOutPath "$INSTDIR\plugins"
		${File} "plugins\in_*.dll"
	SectionEnd

	Section "$(Audio_MP3)" audio_component_mp3
		SectionIn 1 2 3 ;full and audio only
                SetOutPath "$INSTDIR\codecs"
		${File} "codecs\lame.exe"
	SectionEnd
	
	Section "$(Audio_OGG)" audio_component_ogg
		SectionIn 1 2 3
		${File} "codecs\oggenc2.exe"
	SectionEnd
	
	Section "$(Audio_AACPlus)" audio_component_aacplus
		SectionIn 1 2 3
		;${File} "codecs\enc_aacplus.dll"
		${File} "codecs\ct-libisomedia.dll"
		${File} "codecs\aacPlusEnc.dll"
	SectionEnd

	Section "$(Audio_FAAC)" audio_component_faac
		SectionIn 1 2 3
		${File} "codecs\faac.exe"
		;${File} "codecs\libamr.dll"
		${File} "codecs\mp4als.exe"
	SectionEnd

	Section "$(Audio_MPC)" audio_component_mpc
		SectionIn 1 2 3
		${File} "codecs\mppenc.exe"
	SectionEnd
	
	Section "$(Audio_WMA)" audio_component_wma
		SectionIn 1 2 3
		${File} "codecs\cscript.exe"
		${File} "codecs\WMCmd.vbs"
	SectionEnd

	Section "$(Audio_APE)" audio_component_ape
		SectionIn 1 2 3
		${File} "codecs\MACDll.dll"
	SectionEnd
	
	Section "$(Audio_FLAC)" audio_component_flac
		SectionIn 1 2 3
		${File} "codecs\flac.exe"
	SectionEnd
	
	Section "$(Audio_WavPack)" audio_component_wavpack
		SectionIn 1 2 3
		${File} "codecs\wavpack.exe"
	SectionEnd

	Section "$(Audio_OptimFrog)" audio_component_ofr
		SectionIn 1 2 3
		${File} "codecs\ofr.exe"
	SectionEnd

	Section "$(Audio_HelixMP3)" audio_component_hmp3
		SectionIn 1 2 3
		${File} "codecs\hmp3.exe"
	SectionEnd

	Section "$(Audio_NeroAAC)" audio_component_neroaac
		SectionIn 1 2 3
		;${File} "codecs\Aac.dll"
		;${File} "codecs\aacenc32.dll"
		;${File} "codecs\NeroIPP.dll"
		;${File} "codecs\libmmd.dll"
		${File} "codecs\neroAacEnc.exe"
                ;${File} "codecs\neroAacDec.exe"
	SectionEnd

	Section "$(DSP_Plugins)" DSP_Plugins
	      SectionIn 1
	      SetOutPath "$INSTDIR\plugins"
	      ;${File} "plugins\dsp_cmpexp.dll"
	      ;${File} "plugins\dsp_enh.dll"
	SectionEnd

SubSectionEnd
	
SubSection "$(Video)" video_components
    Section "$(Video_Mencoder)" video_component_mencoder
      SectionIn 1
      SetOutPath "$INSTDIR\mplayer"
      ${File} "mplayer\mencoder.exe"
      ;SetOutPath "$INSTDIR\codecs"
      ;${File} "codecs\ffmpeg.exe"
    sectionend

    Section "$(Video_Container)" video_component_muxer
      SectionIn 1
      SetOutPath "$INSTDIR\tools"
      ${File} "tools\mkvmerge.exe"
      ${File} "tools\cygz.dll"
      ${File} "tools\libcharset.dll"
      ${File} "tools\libebml.dll"
      ${File} "tools\libiconv.dll"
      ${File} "tools\libmatroska.dll"
      ${File} "tools\libmtxcommon.dll"
      ${File} "tools\mkvmerge.exe"

      ${File} "tools\MP4Box.exe"
      
      ${File} "tools\pmp_muxer.exe"
      ${File} "tools\pmp_muxer_avc.exe"
    SectionEnd

SubSectionEnd

Section "$(Common_Firefox)" Firefox
  SectionIn 1
  SetOutPath "$INSTDIR"
  File /r "${FILE_PATH}\xulrunner"
  SetOutPath "$INSTDIR\xulapp"
  ${File} "xulapp\application.ini"
  File /r "${FILE_PATH}\xulapp\chrome"
  File /r "${FILE_PATH}\xulapp\defaults"
SectionEnd

Section "$(ShortCut)" shortcut
  SectionIn 1 2 3
  CreateDirectory "$SMPROGRAMS\MediaCoder"
  CreateShortCut "$SMPROGRAMS\MediaCoder\MediaCoder's Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\MediaCoder\MediaCoder.lnk" "${MAIN_APP}"
  CreateShortCut "$SMPROGRAMS\MediaCoder\Uninstall MediaCoder.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section "$(Desktop_ShortCut)" desktop_shortcut
  SectionIn 1 2
  CreateShortCut "$DESKTOP\MediaCoder.lnk" "${MAIN_APP}"
SectionEnd

Section "$(Quick_ShortCut)" quick_shortcut
  CreateShortCut "$QUICKLAUNCH\MediaCoder.lnk" "${MAIN_APP}"
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "$(PRODUCT_WEB_SITE)"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "${MAIN_APP}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "${MAIN_APP}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "$(PRODUCT_WEB_SITE)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd
; --------------------------------------

Function .onInit
	InitPluginsDir
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "$(^Name)") i .r1 ?e'
	Pop $0 
	StrCmp $0 0 +3 
		MessageBox MB_OK|MB_ICONEXCLAMATION "$(Mutex)" 
		Quit
		
	!insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

;Function .onSelChange ;set dependent in this function
;FunctionEnd

Function .onMouseOverSection
	!insertmacro MUI_DESCRIPTION_BEGIN
	
	!insertmacro MUI_DESCRIPTION_TEXT ${main_components} "$(Main_Description)"

	!insertmacro MUI_DESCRIPTION_TEXT ${audio_components} "$(Audio_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${winamp_in_plugin_components} "$(Winamp_in_Plugin_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_mp3} "$(Audio_MP3_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_ogg} "$(Audio_OGG_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_neroaac} "$(Audio_NeroAAC_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_faac} "$(Audio_FAAC_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_mpc} "$(Audio_MPC_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_wma} "$(Audio_WMA_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_ape} "$(Audio_APE_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_flac} "$(Audio_FLAC_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_wavpack} "$(Audio_WavPack_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_ofr} "$(Audio_OptimFrog_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${audio_component_hmp3} "$(Audio_HelixMP3_Description)"

	!insertmacro MUI_DESCRIPTION_TEXT ${video_components} "$(Video_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${video_component_mencoder} "$(Video_Mencoder_Description)"
		!insertmacro MUI_DESCRIPTION_TEXT ${video_component_muxer} "$(Video_Container_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${Firefox} "$(Common_Firefox_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${shortcut} "$(ShortCut_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${desktop_shortcut} "$(Desktop_ShortCut_Description)"
	!insertmacro MUI_DESCRIPTION_TEXT ${quick_shortcut} "$(Quick_ShortCut_Description)"
        !insertmacro MUI_DESCRIPTION_END
FunctionEnd

; --------------------------------------
; жض
; --------------------------------------

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\mplayer\mplayer\font\*"
  Delete "$INSTDIR\mplayer\mplayer\*"
  Delete "$INSTDIR\mplayer\*.*"
  Delete "$INSTDIR\codecs\*.*"
  Delete "$INSTDIR\tools\*.*"
  Delete "$INSTDIR\plugins\*.*"

  Delete "$INSTDIR\mediacoder.exe"
  Delete "$INSTDIR\mc.exe"
  Delete "$INSTDIR\*.dll"
  Delete "$INSTDIR\*.xml"
  Delete "$INSTDIR\mediacoder.ini"
  Delete "$INSTDIR\mediacoder.m3u"
  Delete "$INSTDIR\whatsnew.txt"
  Delete "$INSTDIR\readme.txt"

  Delete "$SMPROGRAMS\MediaCoder\Uninstall MediaCoder.lnk"
  Delete "$SMPROGRAMS\MediaCoder\MediaCoder's Website.lnk"
  Delete "$DESKTOP\MediaCoder.lnk"
  Delete "$QUICKLAUNCH\MediaCoder.lnk"
  Delete "$SMPROGRAMS\MediaCoder\MediaCoder.lnk"

  RMDir "$SMPROGRAMS\MediaCoder"
  RMDir /r "$INSTDIR\xulrunner"
  RMDir /r "$INSTDIR\xulapp"
  RMDir /r "$INSTDIR\htdocs"
  RMDir /r "$INSTDIR\codecs\producer"
  RMDir "$INSTDIR\mplayer\mplayer\font"
  RMDir "$INSTDIR\mplayer\mplayer"
  RMDir "$INSTDIR\mplayer"
  RMDir "$INSTDIR\tools"
  RMDir "$INSTDIR\codecs"
  RMDir "$INSTDIR\plugins"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"

  ${RefreshIcon}
  SetAutoClose true
SectionEnd
