#define MAX_PASS_COUNT 3

class CVideoEncoder : public CEncoder
{
public:
	virtual int open() { return -1; }
	virtual int Encode(CString& cmd) { return -1; }
	virtual int close() { return -1; }
	virtual int UpdateSettings(T_ITEM* item) { return 0; }
	virtual int GetPassCount() { return passcount; }
	virtual char* GetCommand(int pass) {
		return pass < passcount ? cmds[pass].GetBuffer() : 0;
	}
	virtual bool CheckAudioSupport(int id) { return true; }
	virtual bool CheckContainerSupport(int id) { return true; }
	virtual char* GetVersionInfo() { return 0; }
	CVideoEncoder():passcount(0),prefNodePath(0) {}
protected:
	CString cmds[MAX_PASS_COUNT];
	int passcount;
	char* prefNodePath;
private:
};

#define ME_DLL "mencoder.dll"
#define ME_EXE "mencoder.exe"

class CDllHelper;

class CMencoder : public CVideoEncoder
{	
public:
	CMencoder():dll(0) {}
	int open();
	int Encode(CString& cmd);
	int close();
	int GetProgress();
	char* GetName() { return "MEncoder"; }
	char* GetOutExt(T_ITEM* item);
	int UpdateSettings(T_ITEM* item);
	bool CheckAudioSupport(int id);
	bool CheckContainerSupport(int id);
	char* GetVersionInfo();
	int GetTargetBitRate(T_ITEM* item);
private:
	void GetAudioOptions(T_ITEM* item, CString& str);
	void ParseConsole(char* consoleText, int consoleBytes);
	bool fLoadDll;
	CDllHelper* dll;
	SHELL_PARAM* sp;
};

class Cffmpeg : public CVideoEncoder
{	
public:
	int open();
	int Encode(CString& cmd);
	int close();
	char* GetName() { return "FFMPEG"; }
	char* GetOutExt(T_ITEM* item) { return "avi"; }
	int GetProgress();
	int UpdateSettings(T_ITEM* item);
	bool CheckAudioSupport(int id);
	bool CheckContainerSupport(int id);
private:
	SHELL_PARAM sp;
};

class Cx264 : public CVideoEncoder
{	
public:
	char* GetName() { return "X264"; }
	char* GetOutExt(T_ITEM* item) { return "264"; }
};