#include "in2.h"
#include "dsp.h"

typedef In_Module* (*WINAMPGETINMODULE2TYPE)();

#define FLAG_DISABLED 1

typedef struct _INPLUGIN_INFO {
	char* pluginfile;
	char* exts;
	char* desc;
	int flags;
	struct _INPLUGIN_INFO *next;
} INPLUGIN_INFO;

typedef struct {
	char* pluginfile;
	HMODULE hDllPlugin;
	winampDSPModule* mod;
	winampDSPHeader* hdr;
	int (*ModifySamples)(struct winampDSPModule *this_mod, short int *samples, int numsamples, int bps, int nch, int srate);
	int modidx;
	int flags;
} DSPPLUGIN_INFO;

#define SETBIT(byte, bit) (byte |= bit)
#define CLRBIT(byte, bit) (byte &= ~bit)
#define ISBITSET(byte, bit) ((byte & bit))

#define IN_BUFFER_SIZE 16*1024

#ifdef __cplusplus
extern "C" {
#endif
void UnloadWinampInPlugin(In_Module* inmod);
In_Module* LoadWinampInPlugin(char* pluginfile, HWND hwndMain);
int ScanWinampInPlugins(char* path, INPLUGIN_INFO* hdr);
void CleanupWinampInPlugins(INPLUGIN_INFO* hdr);

int LoadDspPlugins(DSPPLUGIN_INFO dspinfo[], int fLoadAll);
void UnloadDspPlugins(DSPPLUGIN_INFO dspinfo[], int fUnloadAll);
int ScanDspPlugins(char* path, DSPPLUGIN_INFO** paDspInfo);
int LoadDspPlugin(DSPPLUGIN_INFO* dspinfo);
void UnloadDspPlugin(DSPPLUGIN_INFO* dspinfo);

#ifdef __cplusplus
}
#endif
