#ifndef DEVPLUGIN_H
#define DEVPLUGIN_H

typedef struct {
	char* name;
	int w;
	int h;
	float fps;
	int bitrate;
} PROFILE_INFO;

// mobile phone plugin structures
enum {
	DEV_TYPE_UNSPEC = 0,
	DEV_TYPE_PHONE,
	DEV_TYPE_DMP,
	DEV_TYPE_GAMECONSOLE,
	DEV_TYPE_DISCPLAYER,
	DEV_TYPE_PDA,
	DEV_TYPE_INPUT,
};

enum {
	DEV_EVENT_LOAD = 0,
	DEV_EVENT_UNLOAD,
	DEV_EVENT_START,
	DEV_EVENT_STOP,
	DEV_EVENT_COMPLETE,
	DEV_EVENT_PLAY,
	DEV_EVENT_PREVIEW,
	DEV_EVENT_STOPPLAY,
	DEV_EVENT_CROP,
	DEV_EVENT_REFRESH,
	DEV_EVENT_APPLY,
};

typedef int (*PFN_PLUGIN_NOTIFY)(int event, void* arg);

typedef struct {
	void* (*pfnGetPrefValue)(char* key);
	void (*pfnSetPrefValue)(char* key, void* value);
	void (*pfnEnqueueFile)(char* file, char* alias);
	void (*pfnEnqueueItem)(void* item, char* alias);
	void (*pfnRefreshGui)(int mode);
	void (*pfnShowSettings)(char* key);
} DEV_PLUGIN_API;

typedef struct _DEV_PLUGIN_HEADER {
	char* name;
	int flags;
	PFN_PLUGIN_NOTIFY notify;
	char* xml;
	struct { int x; int y; int w; int h; } screen;
	HINSTANCE hInst;
	HBITMAP hLogo;
	HWND hWnd;
	HWND hScreen;
	HWND hParent;
	DEV_PLUGIN_API* api;
} DEV_PLUGIN_HEADER;

typedef DEV_PLUGIN_HEADER* (*PFN_GET_HEADER)();

#endif