#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "..\..\include\devplugin.h"

#define DEVICE_NAME "Video Disc Player"

int notify(int event, void* arg);

static DEV_PLUGIN_HEADER plugin= {
	DEVICE_NAME,
	DEV_TYPE_DISCPLAYER,
	notify,
	0,
};

extern "C" __declspec(dllexport) DEV_PLUGIN_HEADER* GetPluginHeader()
{
	return &plugin;
}

static int CALLBACK DlgProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch (msg) {
	case WM_COMMAND:
		switch (HIWORD(wParam)) {
		case BN_CLICKED: {
			char *p, buf[16];
			SendDlgItemMessage(hwnd, LOWORD(wParam), WM_GETTEXT, sizeof(buf), (LPARAM)buf);
			p = strchr(buf, ':');
			if (*(WORD*)(p + 1) == '1') {
				*p = 0;
			} else {
				*p = '/';
			}
			plugin.api->pfnSetPrefValue("overall.video.aspect", buf);
			} break;
		default:
			return 0;
		}
		break;
	default:
		return 0;
	}
	return 1;
}

static int notify(int event, void* arg)
{
	switch (event) {
	case DEV_EVENT_LOAD:
		plugin.hWnd = CreateDialog(plugin.hInst, MAKEINTRESOURCE(IDD_DIALOG), plugin.hParent, DlgProc);
		plugin.hScreen = GetDlgItem(plugin.hWnd, IDC_SKIN);
		SendDlgItemMessage(plugin.hWnd, IDC_RADIO1, BM_SETCHECK, BST_CHECKED, 0);
		return plugin.hWnd ? 0 : -1;
	case DEV_EVENT_UNLOAD:
		DestroyWindow(plugin.hWnd);
		plugin.hWnd = 0;
		break;
	}
	return 0;
}

BOOL APIENTRY DllMain( HINSTANCE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH: {
		plugin.hInst = hModule;
		plugin.hLogo = LoadBitmap(hModule,  MAKEINTRESOURCE(IDB_LOGO));
		} break;
	case DLL_PROCESS_DETACH:
		DeleteObject(plugin.hLogo);
		break;
	}
    return TRUE;
}