#include "config.h"
#include "atlstr.h"
#include "processpil.h"
#include "browser.h"
#include "common.h"

extern "C" {
long DisplayHTMLPage(HWND hwnd, LPTSTR webPageName);
void UnEmbedBrowserObject(HWND hwnd);
long EmbedBrowserObject(HWND hwnd);
void ResizeBrowser(HWND hwnd, DWORD width, DWORD height);
}

int CBrowser::Init()
{
	static bool init = false;
	if (init) return 0;
	init = true;
	return (OleInitialize(NULL) == S_OK) ? 0 : -1;
}

void CBrowser::Uninit()
{
	OleUninitialize();
}

void CBrowser::Open(CWindow* parent)
{
	Init();
	Create(WS_POPUP|WS_BORDER|WS_OVERLAPPEDWINDOW,0, parent);
	SetCaption("MediaCoder Web Browser");
}

int CBrowser::OpenURL(LPTSTR url)
{
	if (!hwnd) return -1;
	DisplayHTMLPage(hwnd, url);
	return 0;
}

bool CBrowser::onSize(int width, int height)
{
	ResizeBrowser(hwnd, width, height);
	return true;
}

extern HICON hAppIcon;

bool CBrowser::onCreate()
{
	SetClassLongPtr(hwnd,GCL_HICON,(LONG)hAppIcon); 
	EmbedBrowserObject(hwnd);
	return true;
}

bool CBrowser::onClose()
{
	UnEmbedBrowserObject(hwnd);
	Destroy();
	return true;
}

int CWebBrowser::Open(char* url)
{
	char dir[256];
	char* xulapp = "xulapp\\application.ini";
	CString cmd;
	if (Close()) {
		Sleep(1000);
	}
	memset(&sp, 0, sizeof(sp));
	GetCurrentDirectory(sizeof(dir) - 8, dir);
	cmd = dir;
	cmd += "\\xulrunner\\xulrunner.exe";
	strcat(dir, "\\xulapp");

	if (!FileExist(cmd.GetBuffer()) || !FileExist(xulapp)) {
		ShellExecute(0, "open", url, 0, 0, SW_SHOW);
		return 1;
	}
	cmd.AppendFormat(" ..\\%s", xulapp);
	if (url) {
		cmd += ' ';
		cmd += url;
	}
	sp.pchCommandLine = cmd.GetBuffer();
	sp.pchCurDir = dir;
	sp.flags = SHELL_SHOW_WINDOW;

	SetEnvironmentVariable("USERPROFILE", dir);
	SetEnvironmentVariable("MOZ_NO_REMOTE", "1");
	
	if (ShellExec(&sp)) {
		return -1;
	}

	SetEnvironmentVariable("USERPROFILE", 0);
	return 0;
}

int CWebBrowser::Close()
{
	int ret = 0;
	if (sp.piProcInfo.hProcess) {
		if (!ShellWait(&sp, 0)) {
			ShellTerminate(&sp);
			ret = 1;
		}
		ShellClean(&sp);
	}
	return ret;
}

int CWebBrowser::WaitClose(int timeout)
{
	return sp.piProcInfo.hProcess ? ShellWait(&sp, timeout) : -2;
}
