#include "devplugin.h"
#include "xmlaccessor.h"

#define PLUGIN_XML_ROOT "MediaCoderPlugin"

#define DEV_FLAG_DOCK 0x1
#define DEV_FLAG_SUMMARY 0x2
#define DEV_FLAG_DIALOG 0x4
#define DEV_FLAG_CONFIRM 0x8

typedef struct _DEV_PLUGIN_INFO {
	struct _DEV_PLUGIN_INFO* next;
	char* pluginFile;
	DEV_PLUGIN_HEADER* hdr;
} DEV_PLUGIN_INFO;

typedef struct {
	char* name;
	char* key;
	char* url;
} DEV_PLUGIN_PRESET;

enum {
	TEXT_DEVICE_NAME = 0,
	TEXT_PLAY_BUTTON,
	TEXT_PLAYSTOP_BUTTON,
	TEXT_PREVIEW_BUTTON,
	TEXT_CROP_BUTTON,
	TEXT_START_BUTTON,
	TEXT_STOP_BUTTON,
	TEXT_FF_BUTTON,
	TEXT_SET_TIME,
	TEXT_COUNT,
};
#define PRESET_CAT 3
class CDeviceDialog : public COptionDialog
{
public:
	CDeviceDialog();
	~CDeviceDialog();
	int Open(char* pluginToShow);
	int Open(int type, char* pluginToShow = 0);
	DEV_PLUGIN_HEADER* GetPluginHeader(int idx = -1);
	DEV_PLUGIN_HEADER* GetPluginHeader(char* name);
	DEV_PLUGIN_INFO* GetPluginInfo(int idx = -1);
	void Refresh();
	char* pluginFile;
	int flags;
private:
	bool onTimer(int id);
	bool onCreate();
	bool onClick(int dlgid);
	bool onClose();
	bool onSelChange(int dlgid);
	bool onChildDestroy();
	void ApplySettings();
	void ShowPlugin(int idx);
	int LoadPlugins(int type);
	void UnloadPlugins();
	int NotifyPlugin(int event, void* arg = 0);
	void RevertTexts();
	void SetTexts();
	void AdjustPluginWindow(HWND hWndPlugin, int catcount);
	CVideoWindow video;
	CDlgPopup popdlg;
	CXML xml;
	int playing;
	int transcoding;
	int index;
	DEV_PLUGIN_PRESET* presetInfo[PRESET_CAT];
	char* pluginUrl;
	HANDLE hSkin;
	DEV_PLUGIN_INFO* plugins;
	int devtype;
	HBITMAP hDefLogo;
	char* texts[TEXT_COUNT];
};
